/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.financial.settlement.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.financial.settlement.entity.MaintainData;
import com.jeeplus.modules.sg.financial.settlement.mapper.DataMaintenanceMapper;
import com.jeeplus.modules.sg.financial.settlement.util.ExcelWriter;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.util.List;


@Service
@Transactional(readOnly = true)
public class DataMaintenanceService extends CrudService<DataMaintenanceMapper, MaintainData> {

	@Autowired
	private DataMaintenanceMapper dataMaintenanceMapper;

	public MaintainData get(String id) {
		return super.get(id);
	}
	
	public List<MaintainData> findList(MaintainData maintainData) {
		return super.findList(maintainData);
	}
	
	public Page<MaintainData> findPage(Page<MaintainData> page, MaintainData maintainData) {
		return super.findPage(page, maintainData);
	}
	
	@Transactional(readOnly = false)
	public void save(MaintainData maintainData) {
		super.save(maintainData);
	}

	@Transactional(readOnly = false)
	public void saveList(List<MaintainData> list) {
		for(MaintainData maintainData : list){
			maintainData.preInsert();
		}
		dataMaintenanceMapper.insertList(list);
	}
	
	@Transactional(readOnly = false)
	public void delete(MaintainData maintainData) {
		super.delete(maintainData);
	}

	@Transactional(readOnly = false)
	public void deleteData(String projectId){
		dataMaintenanceMapper.deleteData(projectId);
	}


	public void export(MaintainData maintainData , HttpServletResponse response){
		Workbook workbook = null;
		try {
			List<MaintainData> list = dataMaintenanceMapper.findList(maintainData);
			workbook = ExcelWriter.exportData(list);
			long time = System.currentTimeMillis();
			String outFile = time + ".xlsx";

			OutputStream outputStream = response.getOutputStream();
			response.reset();
			response.setHeader("Content-Disposition", "attachment;filename="+outFile);
			response.setContentType("application/vnd.ms-excel;charset=UTF-8");
			workbook.write(outputStream);
			outputStream.flush();
			outputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
		}







        	}
	
}